uniform sampler2D m_Map;
uniform sampler2D m_Mix;
varying vec2 texCoord;
varying vec2 mixTexCoord;


void main() {
    vec4 mixVal = texture2D(m_Mix, mixTexCoord);
    
    if( mixVal.a < 0.01 )
        discard;
     
    vec4 mapVal = texture2D(m_Map, texCoord);
    
    float alpha = mapVal.a;
    mapVal = mixVal * mapVal;
    mapVal.a = alpha;
    
    gl_FragColor = mapVal;
}

